//20.09.21 - 4.4

#define Max_pause 16777215

#define total_input 96
#define total_output 48


//#define UDP_PORT 8484 //for 192.168.1.70 - io
//#define UDP_PORT 1111 //for 192.168.1.3 - main
#define SD_board_iden  0x03
#define NSD_board_iden  0x07
#define PWM_board_iden 0x05
#define NPWM_board_iden 0x06

#define NEW_PWM 1
#define NEW_SD 2

#define UDP_PORT 1111
#define SEND_TIMEOUT_US 10
#define RECV_TIMEOUT_US 10
#define READ_PCK_DELAY_NS 10000
#define driver_NAME "etcomb"

#define Lit_pack_new 0xAB
#define Lit_pack_old 0xCB
#define Big_pack_new 0xBB

#define Max_sdchanel 5
#define NUM_chanal 6

#define TIME_INTERVAL_ERROR 100


char msg[] = "Hello there!\n";

// structura driver data

typedef struct {
	int sock;
	struct sockaddr_in addr;
	__u8 read_pack[1400];
	__u8 first_run;
	__u8 block;
	__u8 SD_board_num;
	__u8 PWM_board_num;
	//tests signals
	hal_u32_t *test;
	hal_u32_t *testi;
	
	// hal work signals
  	hal_bit_t *digital_in[total_input];    /* ptrs for digital input pins 16 */
	hal_bit_t *digital_in_n[total_input];
  	hal_bit_t *digital_out[total_output];    /* ptrs for digital output pins 8 */
  
  	hal_bit_t *digital_lin[4];    /* ptrs for digital input pins 4 */
	hal_bit_t *digital_lin_n[4];
  	hal_bit_t *digital_lout[2];    /* ptrs for digital output pins 2 */
  
	hal_bit_t *enable_dr; 

	hal_bit_t   *index_en[NUM_chanal];
	hal_float_t *enccounts[NUM_chanal];
	hal_float_t *encscale[NUM_chanal];
	hal_float_t *encvel[NUM_chanal];

	hal_float_t *outscale[NUM_chanal];
	hal_float_t *dcontrol[NUM_chanal];

	hal_float_t *sdscale[Max_sdchanel];
	hal_float_t *digital_out_step[Max_sdchanel];
	hal_float_t *sd_counts[Max_sdchanel];
	hal_bit_t 	*invert_dir[Max_sdchanel];
	hal_float_t *Limp[Max_sdchanel];

	__u32 last_pause[Max_sdchanel];

	hal_u32_t *versionb;
	hal_u32_t *type;

	hal_bit_t *WD_lock;
	hal_bit_t *reset_wd;
	
	
	__u8 last_reset;
	__u32 count_period;
	__u8 flag_last_err;
	

	hal_u32_t *total_error;
	hal_u32_t *error_time;
	

	__s32 enc_lv[NUM_chanal];

} data_t;

// structura packets data for MAIN board

typedef struct {
	__u8 ident;
	__u32 enc0;
	__u32 enc1;
	__u32 enc2;
	__u32 enc3;
	__u32 enc4;
	__u32 enc5;
	__u8 enc_zero;//wd_lock[7]  ([25])
	__u8 input_b0;
	__u8 input_b1;
	__u8 ffwork;//flag_work[7],lock_inp[3:0]
	__u8 data_byte;//([29])
	__u32 SD_FB0;//[7:0][15:8][23:16][31:24]
	__u32 SD_FB1;
	__u32 SD_FB2;
	__u32 SD_FB3;
	__u32 SD_FB4;
	__u32 wpause0;//[7:0][15:8][23:16][6'b0,25,24]
	__u32 wpause1;
	__u32 wpause2;
	__u32 wpause3;
	__u32 wpause4;
	
} pack_mainR_t;

typedef struct {
	__u8 ident;
	__u8 Gout_pin;//[7:0]
	__u8 Lout_pin;//[1:0]
	__u8 index;//[4:0]
	__u8 contrl_dat;//res_wd[7],dr_en[4],ext_wd[3],spi_en[0]    
	__u8 data_byte;
	__u16 pwm_out0;
	__u32 SD_data0;
	__u32 SD_data1;
	__u32 SD_data2;
	__u32 SD_data3;
	__u32 SD_data4;

} pack_mainW_t;

typedef struct {
	__u8 confiure;
	__u8 ext_input;
	__u8 ext_output;
}ext_conf_t;

typedef struct {
	__u8 start_input;
	__u8 start_output;
}start_cels_t;


ext_conf_t Configuration[]={
	{0,2,1},
	{1,4,2},
	{2,0,0},
	{3,4,5}
};

start_cels_t Startp[]={
	{0,0},
	{32,18},	//pwm
	{72,28} //SD
};


///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///    STEP DIR FUNCTIONS
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////

__s32 DDcontr(void *farg,__u8 exr)
{
// Ti = 1000ns
// Tots = 20ns
// Ti_ots = Ti/Tots;
#define L_imp 2
#define Ti_ots 50

	data_t *data_sd;

	__u8 ttz;
	__u32 temp,pack,pause_up;
	float V_cmd;
	__u32  L_N_imp;

	data_sd = farg;

	V_cmd = *(data_sd-> digital_out_step[exr]);
	
	//limp
	L_N_imp = (__u32)*(data_sd-> Limp[exr]) * 2;
	L_N_imp = L_N_imp & 0x0000000F;
	if(L_N_imp == 0) L_N_imp = 4;

	//Направление	

	pack = 0;		//установка dir(в переменной pack будем собирать посылку)
	if(V_cmd<0) 
	{
    		pack=1;	      //установка dir
    		V_cmd = -V_cmd; //модуль скорости
  	}
	//inverse
	if(*data_sd-> invert_dir[exr])
	pack = pack ^ 0x00000001;



 	//Ограничение Vin
	if(V_cmd >10) V_cmd = 10;

	ttz = 0x01; // Флаг разрешения выдачи STEP
	if(V_cmd != 0)

		pause_up = (__u32)((10/V_cmd)*(Ti_ots*L_imp + 1));

	else
		{
			pause_up = Max_pause;
			ttz = 0;
		}

  	if(pause_up > Max_pause)
		{
			pause_up = Max_pause;
			ttz = 0;
		}

	//enable
  	pack <<= 1;
	pack = pack | ttz;

	//pouse
	pack <<= 30;
	temp = pause_up & 0x00ffffff;
	pack = pack | temp;

	if(ttz) data_sd->last_pause[exr] = pack & 0x80FFFFFF;

	//limp
	L_N_imp <<= 24;
	pack = pack | L_N_imp;

	return pack;
}

